def ProbM(myBP): # myBP is a boolean polynomial being converted to probabilty expression
    if type(myBP) == sage.rings.integer.Integer:
        if myBP%2 == 0:
            return QQ(0)
        else:
            return QQ(1)
    myBP.variables()
    mystr = str(myBP.variables()) # converting all uppers to lower and lowers to uppercase
    newstr = ""
    for l in mystr:
        if l.isupper():
            newstr = newstr + "1" # gotta mark them as upper or lower
        else:
            newstr = newstr + "0"
    NewGens = ""
    for ii in range(len(mystr)):
        if newstr[ii] == "1":
            NewGens = NewGens + mystr[ii].lower()
        else:
            NewGens = NewGens + mystr[ii].upper() # if boolean variable XcGGt1u then, prob var is xCggT1U etc.
    NewGens = NewGens[1:len(NewGens) - 1] # generators for probabilty polynomial assuming boolean generators are independent
    if len(myBP.variables()) == 1:
        NewGens = NewGens.replace(',','')
    CPR = PolynomialRing(QQ,len(myBP.variables()),NewGens.replace(', ',','),order='invlex')
    CPR.inject_variables()
    nn = myBP.nvariables() # number of generators in boolean polynomial
    BPvars = myBP.variables()
    BPmons = myBP.monomials()
    atoms = 2**nn # number of atoms in corresponding boolean algebra
    # should abort this with error, if too many variables in polynomial
    Mvect = [0]*atoms
    for jj in range(len(BPmons)):
        mm = 0
        for kk in range(len(BPmons[jj].variables())):
            mm = mm + 2**BPvars.index(BPmons[jj].variables()[kk])
        Mvect[mm] = 1
    Mvect.reverse() 
    # Mvect order for instance is (X111,X110,X101,X100,X011,X010,X001,X000) has two nonequiv intepretations
    # as monomials or atoms example was for three variables
    Mvect = vector(Mvect)
    MGinv = matrix(QQ,[1])
    for ii in range(1,nn+1):
        MGinv = block_matrix(QQ,2,2,[MGinv,-MGinv,0,MGinv],subdivide=False) # creating inverse of multigrade operator 'AND' matrix MG
        # modulo 2 it's an involution however...
        # MG and MGinv are upper triangular, MG is like Sierpinski triangle see  
        # https://commons.wikimedia.org/wiki/File:Multigrade_operator_AND.svg
    Avect = (MGinv*Mvect)%2
    Pvect = MGinv*Avect # convert from boolean ring (mons) to boolean algebra (atoms) then to probability polynomial
    # ((MGinv*Mvect)%2) is the atoms vector equivalent to the monnomials vector Mvect
    # Pvect are the coefficients of prob poly in CPR
    newpoly = CPR(1)
    for ii in range(0,len(CPR.gens())):
         newpoly = newpoly*(CPR(1) + CPR.gen(ii)) # to create all possible monomials in CPR
    return Pvect*vector(newpoly.monomials()) # inner product of the two vectors to create prob poly